<?php

namespace Drupal\jmol\Plugin\Field\FieldFormatter;

use Drupal\Core\Field\FieldItemListInterface;

/**
 * Plugin implementation of the 'jmol' formatter.
 *
 * @FieldFormatter(
 *   id = "jmol",
 *   label = @Translation("Jmol object"),
 *   field_types = {
 *     "file"
 *   }
 * )
 */
class JmolFileFormatter extends JmolFormatterBase {

  /**
   * {@inheritdoc}
   */
  public function view(FieldItemListInterface $items, $langcode = NULL) {
    $elements = parent::view($items, $langcode);
    return $elements;
  }


  /**
   * {@inheritdoc}
   */
  public function viewElements(FieldItemListInterface $items, $langcode) {
    $elements = [];
    foreach ($this->getEntitiesToView($items, $langcode) as $delta => $file) {
      $uri = $file->getFileUri();
      $path = '/sites/default/files/' . substr($uri, 9);
      $info = $this->baseInfo();
      $info['src'] = $path;
      $elements = [
        '#type' => 'jmol',
        '#info' => $info,
      ];
    }

    return $elements;
  }

}
